#!/bin/bash
RES_0=/tmp/res_netprf_0
RES_1=/tmp/res_netprf_1
RES_2=/tmp/res_netprf_2
RES_3=/tmp/res_netprf_3
RES_4=/tmp/res_netprf_4
RES_5=/tmp/res_netprf_5
RES_6=/tmp/res_netprf_6
rm $RES_0 $RES_1 $RES_2 $RES_3 $RES_4 $RES_5 $RES_6 > /dev/null 2>&1

echo
echo =================================================
echo "Изделие должно обеспечивать одновременную работу 7-ми каналовш связи:
- 4-х агрегированных интерфейсов Ethernet по два интерфейса в каждом.
  При этом должна быть обеспечена одновременная работа пакетами по 128 байт
- двух интерфейсов Ethernet при работе пакетами по 128 байт;
- интерфейса Ethernet для межкомплексного обмена при работе пакетами по 128 байт."
echo
if [ $# -ne 14 ]
then
    DFLT="\
        IP0=1.1.0.2; CPU_0=0;\
        IP1=1.1.1.2; CPU_1=2;\
        IP2=1.1.2.2; CPU_2=2;\
        IP3=1.1.3.2; CPU_3=3;\
        IP4=1.1.4.2; CPU_4=1;\
        IP5=1.1.5.2; CPU_5=0;\
        IP6=1.1.6.2; CPU_6=1;"
#     echo "Использование: `basename $0` <IP_E1000> <CPU_4> <IP0> <CPU_0> <IP1> <CPU_1> <IP2> <CPU_2> <IP3> <CPU_3> <IP5> <CPU_5> <IP6> <CPU_6> "
    eval $DFLT
else
    IP4=$1; CPU_4=$2; shift 2
    IP0=$1; CPU_0=$2; shift 2
    IP1=$1; CPU_1=$2; shift 2
    IP2=$1; CPU_2=$2; shift 2
    IP3=$1; CPU_3=$2; shift 2
    IP5=$1; CPU_5=$2; shift 2
    IP6=$1; CPU_6=$2
fi
ssh $IP0 "systemctl stop mysql.service
systemctl stop apache2.service
systemctl stop postgresql.service
systemctl stop postgresql@9.6-main.service
systemctl stop system-postgresql.slice
systemctl stop nagios3.service
systemctl stop cups.service
systemctl stop avahi-daemon.service
systemctl stop avahi-daemon.socket
systemctl stop quagga" > /dev/null 2>&1

cd /opt/mcst/check/OSLTC/tlinks/netperf_tc/root/usr/local/bin

T0="./netperf -t UDP_STREAM -H $IP0 -T ${CPU_0},${CPU_0} -- -m 128"
T1="./netperf -t UDP_STREAM -H $IP1 -T ${CPU_1},${CPU_1} -- -m 128"
T2="./netperf -t UDP_STREAM -H $IP2 -T ${CPU_2},${CPU_2} -- -m 128"
T3="./netperf -t UDP_STREAM -H $IP3 -T ${CPU_3},${CPU_3} -- -m 128"
T4="./netperf -t UDP_STREAM -H $IP4 -T ${CPU_4},${CPU_4} -- -m 128"
T5="./netperf -t UDP_STREAM -H $IP5 -T ${CPU_5},${CPU_5} -- -m 128"
T6="./netperf -t UDP_STREAM -H $IP6 -T ${CPU_6},${CPU_6} -- -m 128"

CPU_MASK=2;  # только к процессору № 1
for COMM in drweb systemd snmpd Xorg sshd rsyslogd ypbind esc- xfdesktop xinput jbd bash dbus cups polkitd popsquares nscd xinetd chronyd kthreadd rcu_sched cron atd slim nginx snort xfce4-session xfsettingsd kauditd xlyap shadebobs ossec-syscheckd ossec-analysisd ossec-remoted nmbd php5-fpm filed; do
#	echo -n "$COMM "
	for PID in `ps -e -o pid,comm | awk /$COMM'/{print $1}'`; do
		/usr/bin/proc_bind $PID $CPU_MASK;
		renice 19 -p $PID > /dev/null
	done
done
echo Запуск 7 тестов одновременно:
echo для агрегированных MGE
echo $T0 | tee $RES_0
echo $T1 | tee $RES_1
echo $T2 | tee $RES_2
echo $T3 | tee $RES_3

echo для MFE
echo $T5 | tee $RES_5
echo $T6 | tee $RES_6

echo для LE1000
echo $T4 | tee $RES_4

ssh $IP0 "sysctl dev.sunlance.napi_cpu.eth5=2"

$T0 >> $RES_0 2>&1 &
$T1 >> $RES_1 2>&1 &
$T2 >> $RES_2 2>&1 &
$T3 >> $RES_3 2>&1 &
$T5 >> $RES_5 2>&1 &
$T6 >> $RES_6 2>&1 &
$T4 >> $RES_4 2>&1 &
wait
ssh $IP0 "sysctl dev.sunlance.napi_cpu.eth5=-1" > /dev/null
echo Тесты завершены
echo ИТОГ
echo -n "Получены скорости MGE: "
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_0
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_1
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_2
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_3
echo " Мбит/сек"

echo -n "Получены скорости MFE: "
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_5
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_6
echo " Мбит/сек"

echo -n "Получена скорость LE1000: "
awk '/Messages/{getline;getline;getline;getline;getline; printf("%5.1f ", $4)}' $RES_4
echo " Мбит/сек"

#grep '^[.0-9]' $RES_4 $RES_0 $RES_1 $RES_2 $RES_3 $RES_5 $RES_6
#rm $RES_4 $RES_0 $RES_1 $RES_2 $RES_3 $RES_5 $RES_6
#ssh 1.1.1.2 "pidstat 1 11 > ~/ps1 &"; pidstat 1 11 > ~/ps11 & ./uvksa_1.sh; scp 1.1.1.2:~/ps1 ~
