#!/bin/bash
NETPERF=/opt/mcst/check/OSLTC/tlinks/netperf_tc/root/usr/local/bin/netperf
RES_0=/tmp/res_netprf_0

echo =================================================
echo "Производительность сетевой подсистемы при коммутации (forwarding)
    потока IP пакетов между интерфейсами Ethernet,
    должна быть не менее 50 Мбит/с для коротких (128 байт) UDP сообщений"

if [ $# -ne 3 ]
then
    DFLT="IP_SND=1.1.0.3; IP_RECV=1.1.1.2;"
    echo "Использование: `basename $0` <ip_sender> <ip_recv>"
    echo "Установки по умолчанию: $DFLT."
    eval $DFLT
else
    IP_SND=$1
    IP_RECV=$2
fi
echo 1 > /proc/sys/net/ipv4/ip_forward
echo Исполнение netperf на $IP_SND для $IP_RECV. Текущая машина выполняет forwarding
ssh $IP_SND ifconfig eth1 down > /dev/null 2>&1
ssh $IP_SND sysctl net.ipv4.conf.all.snd_num4period=530 > /dev/null 2>&1
#ssh $IP_SND sysctl net.ipv4.conf.all.snd_period_us=10000 > /dev/null 2>&1
#ssh $IP_SND sysctl net.ipv4.conf.all.snd_limsz4period=256 > /dev/null 2>&1
ssh $IP_SND route add default gw 1.1.0.1 
ssh $IP_RECV ifconfig eth0 down > /dev/null 2>&1
ssh $IP_RECV ifconfig bond0 down > /dev/null 2>&1
echo ssh $IP_SND $NETPERF -t UDP_STREAM -H $IP_RECV -- -m 128
ssh $IP_SND $NETPERF -t UDP_STREAM -H $IP_RECV -- -m 128 | tee $RES_0
SPEED_0=`awk '/Messages/{getline;getline;getline;getline;getline; print int($4)}' $RES_0`
if (( SPEED_0 < 50 )); then echo FAIL; else echo PASS; fi
echo 0 > /proc/sys/net/ipv4/ip_forward
ssh $IP_SND ifconfig eth1 up > /dev/null 2>&1
ssh $IP_RECV ifconfig eth0 up > /dev/null 2>&1
ssh $IP_RECV ifconfig bond0 up > /dev/null 2>&1
